cordova.define("cordova-plugin-H5ToNative.H5ToNative", function(require, exports, module) {
var exec = require('cordova/exec');


exports.goUnity = function (arg0, success, error) {
    exec(success, error, 'callPlugin', 'goUnity', [arg0]);
};

exports.goStore = function (arg0, success, error) {
    exec(success, error, 'callPlugin', 'goStore', [arg0]);
};

exports.goInstall = function (arg0, success, error) {
    exec(success, error, 'callPlugin', 'goInstall', [arg0]);
};

exports.goMap = function (arg0, success, error) {
    exec(success, error, 'callPlugin', 'goMap', [arg0]);
};

exports.userLoginOrBinding = function (arg0, success, error) {
    exec(success, error, 'callPlugin', 'userLoginOrBinding', [arg0]);
};

exports.userShare = function (arg0, success, error) {
    exec(success, error, 'callPlugin', 'userShare', [arg0]);
};

exports.gpsTransform = function (arg0, success, error) {
    exec(success, error, 'callPlugin', 'gpsTransform', [arg0]);
};

exports.goDeviceInfo = function (arg0, success, error) {
    exec(success, error, 'callPlugin', 'goDeviceInfo', [arg0]);
};

exports.openCamera = function (selectMode, width, height, success, error) {
	openCamera(selectMode, width, height, success, error);
};

exports.openGallery = function (selectMode, width, height, success, error) {
	imagePicker(selectMode, width, height, success, error);
};

exports.downloadFile = function (url, folder, fileName, success, error, progress) {
	StartDownload(url, folder, fileName, success, error, progress);
};

exports.abortDownload = function () {
	AbortDownload();
};

exports.upLoadFile = function (fileURL, uri, success, error) {
    Upload(fileURL, uri, success, error);
};

exports.createFile = function (path, fileName, str, success, error) {
    CreateFile(path, fileName, str, success, error);
};

exports.readFile = function (path, success, error) {
    ReadFile(path, success, error);
};

exports.delFile = function (path, success, error) {
    DeleteFile(path, success, error);
};

//////////////////////////////////////
exports.cInitRootData=function(){
    initRootData();
};

exports.cAddScenicInfos=function(o,func){
    addScenicInfos(o,func);

};

exports.cRemoveScenicInfos=function(sid){
   removeScenicInfos(sid);
};

exports.cAutoDownload=function(){
    autoDownload();
};

exports.cFinishDownloadFile=function(sid,vIndex){
    finishDownloadFile(sid,vIndex);
};

exports.cClickToDownloadScenic=function(sid){
    clickToDownloadScenic(sid);
};

exports.cGetFinishedInfos=function(flag,func){
      getFinishedInfos(flag,func);
  };
//安卓调用JS函数,需要JS函数先主动调用
  exports.setAndroidCallBack= function (arg0, success, error) {
        exec(success, error, 'callPlugin', 'setAndroidCallBack', [arg0]);
   };
//首页要取得此ID,然后访问接口得到首页展示的5个短视频.
  exports.getShortVideoID= function (arg0, success, error) {
        exec(success, error, 'callPlugin', 'getShortVideoID', [arg0]);
   };
//打开首页或者登录成功后，需要把登录信息发给安卓
  exports.setLoginInfo= function (arg0, success, error) {
        exec(success, error, 'callPlugin', 'setLoginInfo', [arg0]);
   };

     exports.getVersion= function (arg0, success, error) {
           exec(success, error, 'callPlugin', 'getVersion', [arg0]);
      };

});

var createFileSuccess;
var createFileError;

//创建文件
function CreateFile(path, fileName, str, success, error)
{
//	alert("start CreateFile");
	createFileSuccess = success;
	createFileError = error;
	//window.resolveLocalFileSystemURL('file:///storage/emulated/0/TestApp', function(dir) {
	window.resolveLocalFileSystemURL(path, function(dir) {
//		alert("got dir: " + dir);
		dir.getFile(fileName, {create:true}, function(file) {
//			alert("got the file" + file);
			logOb = file;
			writeLog(str);
		});
	});
}
//写文件函数
function writeLog(str) {
	if(!logOb) return;
	logOb.createWriter(function(fileWriter) {
//		fileWriter.seek(fileWriter.length);
		var blob = new Blob([str], {type:'text/plain'});
		fileWriter.write(blob);
//		alert("file created!");
		if (createFileSuccess!=null)
			createFileSuccess("file created!");
	}, createFilefail);
}
//创建文件失败
function createFilefail(e) {
	//alert("Create Filefail");
	if (createFileError!=null)
		createFileError("Create Filefail");
}

var readFileSuccess;
var readFileError;

//读取文件
function ReadFile(path, success, error) {
   //window.resolveLocalFileSystemURL('file:///storage/emulated/0/TestApp/1.txt', gotFile, gotFilefail);
   readFileSuccess = success;
   readFileError = error;
   window.resolveLocalFileSystemURL(path, gotFile, gotFilefail);
}
//读取文件内容
function gotFile(fileEntry) {
	fileEntry.file(function(file) {
		var reader = new FileReader();
		reader.onloadend = function(e) {
			var content = this.result;
//			alert(content.length); //打印文件的文本内容长度
			if (readFileSuccess!=null)
				readFileSuccess(content);
		};
		reader.readAsText(file);
	});
}
//读取文件内容失败
function gotFilefail(e) {
//	alert("FileSystem Error");
	if (readFileError!=null)
		readFileError("FileSystem Error");
}

var delFileSuccess;
var delFileError;

//删除文件
function DeleteFile(path, success, error)
{
	delFileSuccess = success;
	delFileError = error;
	window.resolveLocalFileSystemURL(path, delFile, delFileError);
}
//删除文件成功
function delFile(fileEntry) {
	//alert('delFile.');
	fileEntry.remove(function() {
            //alert('File removed.');
			if (delFileSuccess!=null)
				delFileSuccess('File removed.');
         }, delFileError);
}
//删除文件失败
function delFileError(error) {
  //alert("ERROR: " + error.code);
  if (delFileError!=null)
	delFileError("ERROR: " + error.code);
}


function openCamera(selectMode, width, height, success, error) {
	var srcType = Camera.PictureSourceType.CAMERA;
    var options = setOptions(srcType);
	if (selectMode == "normal") {
		
	}
	else if (selectMode == "thumb") {
        options.targetHeight = width;
        options.targetWidth = height;
    }
    window.navigator.camera.getPicture(function cameraSuccess(imageUri) {
        success(imageUri);
    }, function cameraError(err) {
        error("Unable to obtain picture: " + err, "app");
    }, options);
}

function imagePicker(selectMode, width, height, success, error) {
    var srcType = Camera.PictureSourceType.SAVEDPHOTOALBUM;
    var options = setOptions(srcType);
	
	if (selectMode == "normal") {
		
	}
	else if (selectMode == "thumb") {
        options.targetHeight = width;
        options.targetWidth = height;
    }
	window.navigator.camera.getPicture(function cameraSuccess(imageUri) {
        success(imageUri);
    }, function cameraError(err) {
        error("Unable to obtain picture: " + err, "app");
    }, options);
}

function setOptions(srcType) {
    var options = {
        // Some common settings are 20, 50, and 100
        quality: 50,
        destinationType: Camera.DestinationType.DATA_URL,
        // In this app, dynamically set the picture source, Camera or photo gallery
        sourceType: srcType,
        encodingType: Camera.EncodingType.JPEG,
        mediaType: Camera.MediaType.PICTURE,
        allowEdit: true,//43827ac3f3eeb2967662ce730401615132c1b897,选择相片后,用户可修改头像
        correctOrientation: true  //Corrects Android orientation quirks
    }
    return options;
}

//下载文件全局变量
var url = 'http://192.168.5.113/1/pic.jpg';
var folder = "pics";
var fileName = "pic.jpg";
var downloadSuccess;
var downloadError;
var ft_download = new FileTransfer();
var downloadProgress;
var lastDownloaded;
var t = 0;


//准备下载文件到app的files目录
function StartDownload(_url, _folder, _fileName, success, error, progress) {
    url = _url;
    folder = _folder;
    fileName = _fileName;
    downloadSuccess = success;
    downloadError = error;
    downloadProgress = progress;
    window.resolveLocalFileSystemURL(cordova.file.externalApplicationStorageDirectory + "/files", onFileSystemSuccess, onFileSystemError);
}
function onFileSystemError(e) {
    //alert("onFileSystemError");
    downloadError("onFileSystemError");
};
function onFileSystemSuccess(entry) {
    //alert(entry.toURL());
    entry.getDirectory(folder, {
        create: true,
        exclusive: false
    }, onGetDirectorySuccess, onGetDirectoryFail);
};
function onGetDirectorySuccess(dir) {
    //alert("onGetDirectorySuccess");
    dir.getFile(fileName, {
        create: true,
        exclusive: false
    }, gotFileEntry, errorHandler);
};
function onGetDirectoryFail(e){
    downloadError("onGetDirectoryFail");
}
function gotFileEntry(fileEntry) {
    // logic to write file in respective directory
    //alert("start download");
    doDownload(fileEntry, url, true);
};
function errorHandler(e) {
    // handle error
}

//开始下载
function doDownload(fileEntry, uri, readBinaryData) {

    var fileTransfer = new FileTransfer();
    var fileURL = fileEntry.toURL();
    //下载进度
    fileTransfer.onprogress = function(progressEvent) {
        var perc = Math.floor(progressEvent.loaded / progressEvent.total * 100);
		if (t<1000)
		{
			t = t + 1;
		}
		else
		{
			var speed = (progressEvent.loaded - lastDownloaded);
			downloadProgress(perc, speed, progressEvent.total);
			lastDownloaded = progressEvent.loaded;
			t = 0;
		}
    }
    //下载过程
    fileTransfer.download(
        uri,
        fileURL,
        function (entry) {
            //alert("Successful download...");
            //alert("download complete: " + entry.toURL());
            downloadSuccess("download complete: " + entry.toURL());
            if (readBinaryData) {
              // Read the file...
              readBinaryFile(entry);
            }
            else {
              // Or just display it.
              displayImageByFileURL(entry);
            }
        },
        function (error) {
            //alert("download error source " + error.source);
            //alert("download error target " + error.target);
            //alert("upload error code" + error.code);
            downloadError("download error source " + error.source);
        },
        null, // or, pass false
        {
            //headers: {
            //    "Authorization": "Basic dGVzdHVzZXJuYW1lOnRlc3RwYXNzd29yZA=="
            //}
        }
    );
    ft_download = fileTransfer;
}
//下载后按照图片来显示在网页中
function displayImageByFileURL(fileEntry) {
    var elem = document.getElementById('imageElement');
    elem.src = fileEntry.toURL();
}
//下载后的读取验证
function readBinaryFile(fileEntry) {
    fileEntry.file(function(file) {
		var reader = new FileReader();
		reader.onloadend = function(e) {
			var content = this.result;
            //alert("Read file as Binary String: length : " + content.length); //打印文件的文本内容长度
		};
		reader.readAsBinaryString(file);
	}, onErrorReadFile);
}
function onErrorReadFile(e){
	//alert("ErrorReadFile: "+e);
}

function AbortDownload()
{
    ft_download.abort();
}

function Upload(fileURL, uri, UploadSuccess, Uploaderror)
{
    //var fileURL = "file:///storage/emulated/0/Android/data/org.apache.cordova.myApp/files/pics/pic.jpg"
    //var uri = "http://192.168.5.113/1/php/upload.php";
    //var uri = "http://ptsv2.com/t/xf0su-1553319386/post";
    var options = new FileUploadOptions();
    options.fileKey="fileToUpload";
    options.fileName=fileURL.substr(fileURL.lastIndexOf('/')+1);
    options.httpMethod="POST"; //"PUT/POST"
    options.mimeType = "image/jpeg";
    var params = {};
    // params.Expires = "1553912004";
    // params.OSSAccessKeyId = "LTAIQuzMtrf8wwR6";
    // params.Signature = "lNvsb+pp6mZ9CxqnxhBXYWvKH1o=";
    options.params = params;
    //var headers = {'headerParam':'headerValue'};
    //options.headers = headers;
    var ft = new FileTransfer();
    ft.upload(fileURL, uri, onSuccess, onError, options);
    function onSuccess(r) {
        //alert("Code = " + r.responseCode);
        //alert("Response = " + r.response);
        //alert("Sent = " + r.bytesSent);
        UploadSuccess(r.response);
    }
    //上传进度
    p = document.getElementById("progress");
    ft.onprogress = function(event) {
        var perc = Math.floor(event.loaded / event.total * 100);
        if (p!=null){
            p.innerHTML = perc + "% upLoaded...";
        }
    }
    function onError(error) {
       //alert("An error has occurred: Code = " + error.code);
       //alert("upload error source " + error.source);
       //alert("upload error target " + error.target);
       Uploaderror("An error has occurred: Code = " + error.code);
    }
}



///////////////////////////////////////JS版下载管理/////////////////////////////////////
//////////////////List定义
function CYQ_List() {
    this.list = new Array();
};

function InitDownload() {

Array.prototype.toList=function () {
	var list=new CYQ_List();
	for(var i=0;i<this.length;i++){
		list.add(this[i]);
	}
	return list;
}

CYQ_List.prototype.add = function(object) {
	this.list.push(object);
};

CYQ_List.prototype.addAll = function(listObject) {
    this.list = this.list.concat(listObject.list);
};

CYQ_List.prototype.get = function(index) {
    return this.list[index];
};

CYQ_List.prototype.getObjectIndex = function(object) {
 var i = 0;
 for(; i < this.list.length; i++) {
     if( this.list[i] === object) {
        return i;
     }
 }
 return -1;
};

CYQ_List.prototype.contains = function(object) {
    return this.getObjectIndex(object)!=-1;
};

CYQ_List.prototype.removeIndex = function(index) {
    var object = this.list[index];
    this.list.splice(index, 1);
    return object;
};


CYQ_List.prototype.remove = function(object) {
    var i = this.getObjectIndex(object);
    if(i==-1) {
        return null;
    } else {
        return this.removeIndex(i);
    }
};

CYQ_List.prototype.clear = function() {
    this.list.splice(0, this.list.length);
};

CYQ_List.prototype.count = function() {
    return this.list.length;
};

CYQ_List.prototype.subList = function(start, end) {
    var list = new List();
    list.list = this.list.slice(start, end);
    return list;
};

CYQ_List.prototype.isEmpty = function() {
    return this.list.length == 0;
};

//////////////////////////////////////////////////////////DownloadScenicInfos///////////////////////////////////////////////////////////
DownloadScenicInfos.prototype=new CYQ_List();

DownloadScenicInfos.prototype.getProcess=function () {
		var count=0;
		for (var i = 0; i < this.count(); i++) {
			if(this.get(i).finished==true)
			{
				count++;			}
		}
		return count/this.count()*1.0;
	}

DownloadScenicInfos.prototype.getReadyToDownloadInfo=function () {
		for(var j = 0; j < this.list.length; j++){
			var vinfo=this.list[j];
			if(!vinfo.finished){
				return {"sid":this.scenicID,"vIndex":j,"url":vinfo.video_url};
			}
		}
		return null;
	}

//////////////////////////////////////////////////////////DownloadListRoot///////////////////////////////////////////////////////////
DownloadListRoot.prototype=new CYQ_List();

DownloadListRoot.prototype.findSID=function (id) {
		for (var i = 0; i < this.count(); i++) {
			if(this.get(i).scenicID==id)
			{
				return this.get(i);
			}
		}
		return null;
	}

DownloadListRoot.prototype.addScenic=function (s,func) {
        //先查找有无重复景区
		var res=this.findSID(s.scenicID);
		if(res!=null)
		{
			func(true);
			return;
		}

		var sinfo=new DownloadScenicInfos();
		sinfo.scenicID=s.scenicID;
		sinfo.videoImg=s.videoImg;
		sinfo.videoName=s.videoName;
		for (var i = 0; i < s.data.length; i++) {
			var vinfo=new DownloadVideoInfos();
			vinfo.videoID= s.data[i].videoID;
			vinfo.video_url= s.data[i].video_url;
			vinfo.reverse=s.data[i].reverse;

			vinfo.finished= false;
			vinfo.downloading=false;
			vinfo.process= 0;
			sinfo.add(vinfo);
		}
		this.add(sinfo);
		this.toBeContinue=true;
		console.log("成功添加!");
		saveRootData();
		if(this.currentDownloadScenic==null)
		{
		     autoDownload();//如果没下载则下载
              console.log("添加景区,立即下载!");
		}
		else{
              console.log("添加景区,正在下载中,不下载新的数据!");
		}
        func(false);
	}

//删除数据前需要主动判断是否在下载 中,如果是要先暂停再删除
DownloadListRoot.prototype.removeScenic=function (sid) {
        if(this.currentDownloadScenic!=null&&this.currentDownloadScenic.sid==sid)
        {
            console.log("要删除的景区正在下载,先暂停后删除");
            clickToDownloadScenic(sid);
        }
		for (var i = 0; i < this.list.length; i++) {
			if(this.list[i].scenicID==sid)
			{
			    var vs=this.list[i];

			    for (var j = 0; j <vs.list.length; j++) {
                    var tfileName= rootFilePath+"/"+sid+"/"+vs.list[j].videoID+".mp4";
                    var tfileNameR= rootFilePath+"/"+sid+"/"+vs.list[j].videoID+"_r.mp4";
                    console.log(tfileName);
			        DeleteFile(tfileName, function(s){console.log(tfileName+"del Success!");},  function(s){console.log(tfileName+"del Error!");});
			         DeleteFile(tfileNameR, function(s){console.log(tfileNameR+"del Success!");},  function(s){console.log(tfileNameR+"del Error!");});
			    }
				this.removeIndex(i);
				//console.log('removeIndex:',i,"sid:",sid,"  OK");
				//alert('removeIndex:'+i+"sid:"+sid+"  OK");
			}
		}
		//如果有重复是连续删除后才保存
		saveRootData();
	}

DownloadListRoot.prototype.getReadyToDownloadInfo=function () {//从全部未下载完的文件里找一个
		for (var i = 0; i < this.list.length; i++) {
			var sinfo=this.list[i];
			for(var j = 0; j < sinfo.list.length; j++){
				var vinfo=sinfo.list[j];
				if(!vinfo.finished){
					return {"sid":sinfo.scenicID,"vIndex":j,"url":vinfo.video_url};
				}
			}

		}
		return null;
	}

DownloadListRoot.prototype.getFinishedInfos=function (flag,func) {
		var newres=new Array();
		for (var i = 0; i < this.count(); i++) {
			var sinfo=this.get(i);
			if(this.get(i).finished==flag){
				newres.push({"sid":sinfo.scenicID,"process":sinfo.runtimeProgress,"videoImg": sinfo.videoImg , "videoName":sinfo.videoName,"downloadSure":sinfo.downloading });
			}
		}
		func(newres);
		//return newres;
	}

}


//一个视频文件的信息
function DownloadVideoInfos(o) {
	this.videoID=null;
	this.video_url=null;
	this.reverse=false;//是否是倒播视频

	this.downloading=false;
	this.finished=false;
	this.process=0;
}

//景区信息
//获取当前正在下载的文件地址
//设置某文件下载完成
function DownloadScenicInfos(o) {
	CYQ_List.apply(this, arguments);
	//缺少图片
		this.videoName=null;
    	this.videoImg=null;
	this.scenicID=null;
	this.finished=false;
	this.downloading=false;
	this.process=0;//完成进度   完成的数量/景区文件个数
	this.runtimeProgress=0;//实时进度,比如一个景区4个文件,现在下载完2个了.正在下第3个.此值表示为0.5+0.25*  a%
}

//下载列表
//添加景区信息,删除景区信息
//获取当前正在下载的文件
//获取当前已下载景区
//获取当前未完成景区
//启动自动下载
function DownloadListRoot() {
	CYQ_List.apply(this, arguments);
	this.toBeContinue=false;//开启下载页后是否继续下载
	this.currentDownloadScenic=null;//{"sid":i,"vIndex":j};//用于暂停和切换下载
}

/////////////////////////////////////////////////////////////cordova对外提供接口//////////////////////////////////////////
var root=null;
var rootFilePath;//initRootData中有.
var rootFileName;

function JsonToObj(str) {
	var objRoot=new DownloadListRoot();
	var jsObj=JSON.parse(str);//直接转成对象会丢失对象的继承类型
	objRoot.toBeContinue=jsObj.toBeContinue;
	objRoot.currentDownloadScenic=jsObj.currentDownloadScenic;
	for (var i = 0; i < jsObj.list.length; i++) {
		//每个景区
		var rootScenicInfo=new DownloadScenicInfos();
	    var	jsScenicInfo=jsObj.list[i];
	    rootScenicInfo.scenicID=jsScenicInfo.scenicID;
	    rootScenicInfo.videoName=jsScenicInfo.videoName;
	    rootScenicInfo.videoImg=jsScenicInfo.videoImg;
	    rootScenicInfo.finished=jsScenicInfo.finished;
	    rootScenicInfo.downloading=jsScenicInfo.downloading;
	    rootScenicInfo.process=jsScenicInfo.process;
	    for (var j = 0; j < jsScenicInfo.list.length; j++) {
	    	//每个视频信息
	    	var rootVideoInfo=new DownloadVideoInfos();
	    	var jsVideoInfo=jsScenicInfo.list[j];
	    	rootVideoInfo.videoID=jsVideoInfo.videoID;
	    	rootVideoInfo.video_url=jsVideoInfo.video_url;
	    	rootVideoInfo.reverse=jsVideoInfo.reverse;
	    	rootVideoInfo.downloading=jsVideoInfo.downloading;
	    	rootVideoInfo.finished=jsVideoInfo.finished;
	    	rootVideoInfo.process=jsVideoInfo.process;
	    	rootScenicInfo.add(rootVideoInfo);
	    }
	    objRoot.add(rootScenicInfo);
	}
	return objRoot;
}

function initRootData() {
    rootFilePath="file:///storage/emulated/0/Android/data/cn.kdkdcn.hearttour/files";
    rootFileName="/downloadList.txt";
	//从文件读取,读取不到则创建空的
	InitDownload();
	//此处有BUG2,1直接从JSON恢复对象导致root没有类型
	ReadFile(rootFilePath+rootFileName,
	    function(s){  root= JsonToObj(s);console.log("LoadDataOK!!!!!"); },
	    function(e){ root=new DownloadListRoot();root.toBeContinue=true; console.log("CreateDataOK!!!!"); saveRootData(); }
	    );
}
function saveRootData(){
    CreateFile(rootFilePath,rootFileName,JSON.stringify(root), null,null);
    //alert("saveRootData success!");
}

function addScenicInfos (o,func) {
    //alert(root.toBeContinue+ "_file:"+rootFilePath);
   	root.addScenic(o,func);
}

function removeScenicInfos (sid) {
	//删除文件
	root.removeScenic(sid);
}

function getReadyToDownloadInfo(){
	return root.getReadyToDownloadInfo();
}

//景区........index与id
function finishDownloadFile_back (sid,vIndex) {
		var sInfo=root.findSID(sid);
		if(sInfo==null) return;
		sInfo.get(vIndex).finished=true;
		sInfo.get(vIndex).downloading=false;
		sInfo.process=sInfo.getProcess();
		//检测是否景区内全部完成
		var allFinished=true;

		for (var i = 0; i < sInfo.count(); i++) {
			if(sInfo.get(i).finished==false){
				allFinished=false;
			}
		}
		if(allFinished)
		{
			sInfo.finished=true;
			sInfo.downloading=false;
			console.log('景区:',sid,"全部完成")
		}
		root.toBeContinue=true;
		saveRootData();
		//继续开始新的下载
		autoDownload();
}

function finishDownloadFile (sid,vIndex) {
		var sInfo=root.findSID(sid);
		if(sInfo==null) return;
		sInfo.get(vIndex).finished=true;
		sInfo.get(vIndex).downloading=false;
		sInfo.process=sInfo.getProcess();
		//检测是否景区内全部完成
		var allFinished=true;

		for (var i = 0; i < sInfo.count(); i++) {
			if(sInfo.get(i).finished==false){
				allFinished=false;
			}
		}
		if(allFinished)
		{
			sInfo.finished=true;
			sInfo.downloading=false;
			console.log('景区:',sid,"全部完成")
			root.toBeContinue=true;
			saveRootData();
			autoDownload();
		}
		else
		{
			//继续从当前景区开始新的下载
			var res= sInfo.getReadyToDownloadInfo();//找到一个需要下载的,开始下载
			if(res==null)
			{
		    	root.toBeContinue=false;
		    	saveRootData();
				console.log('没有可以继续的下载内容');
	        	return;
			}
			saveRootData();
			downdloadNewClick(res.sid);
		}
}


function autoDownload() {
	if(!root.toBeContinue)
	{
		console.log('没有自动开始下载')
		return;
	}
	var res= getReadyToDownloadInfo();//找到一个需要下载的,开始下载
	if(res==null)
	{
	    root.toBeContinue=false;
	    saveRootData();
		console.log('没有可以继续的下载内容');
        return;
	}
	downdloadNewClick(res.sid);
}

function downdloadNewClick (sid) {
    var sres=root.findSID(sid);
	if(sres==null) return;
	var nres= sres.getReadyToDownloadInfo();
	if(nres!=null)
	{
		console.log('开始下载sid:'+sid)
		root.findSID(nres.sid).downloading=true;
		var vInfo=root.findSID(nres.sid).get(nres.vIndex);
		vInfo.downloading=true;
		root.toBeContinue=true;
        root.currentDownloadScenic=nres;
		//下载//download();

        var tfileName= rootFilePath+"/"+sid+"/"+vInfo.videoID+".mp4";
        var truePath=vInfo.videoID+".mp4";
        if(vInfo.reverse==true)
        {
            truePath=vInfo.videoID+"_r.mp4";
        }

        StartDownload(vInfo.video_url,sid+"",truePath,
        function(successStr){
            console.log("success>nres.sid:"+nres.sid +"nres.vIndex:"+nres.vIndex);
            finishDownloadFile(nres.sid,nres.vIndex);
        },
        function(errorStr){ console.log("=========errorStr===============>"+errorStr);},
        function(progress){   setRuntimeProgress(nres.sid, progress); console.log("runtimeProgress:"+getScenicRuntimeProgress(nres.sid));}
        );
	}
}

function setRuntimeProgress(sid,p)
{
    var sInfo=root.findSID(sid);
	if(sInfo==null) return ;
    sInfo.runtimeProgress=sInfo.process+1.0/sInfo.count()* p/100;
}

function getScenicRuntimeProgress(sid) {
	var sInfo=root.findSID(sid);
	if(sInfo==null) return 0;
	return sInfo.runtimeProgress;
}

function clickToDownloadScenic (sid) {
	var r=root.currentDownloadScenic;
	//if(index<root.count())
	{
		if(r==null){//原先是暂停,则点击直接下载
			console.log("直接开始下载新的点击");
			downdloadNewClick(sid);
		}
		else{//原先是下载,则点击
			if(sid==r.sid)
			{//点击与下载的是同一个,暂停当前
				root.findSID(r.sid).downloading=false;
				root.findSID(r.sid).get(r.vIndex).downloading=false;
				console.log("暂停下载景区:"+r.sid);
				root.toBeContinue=false;
				root.currentDownloadScenic=null;
				AbortDownload();
			}
			else{//不是同一个,则暂停那个,下载新的.
				root.findSID(r.sid).downloading=false;
				root.findSID(r.sid).get(r.vIndex).downloading=false;
				console.log("暂停其它景区下载,开始点击的景区下载");
				AbortDownload();


				//下载新的
				downdloadNewClick(sid);
			}
		}
	}
}

function getFinishedInfos(b,func) {
	root.getFinishedInfos(b,func);
	/*true表示完成下载的.false表示没完成 的下载 ,返回这样的结果
	[ { sid: 1, process: 0, videoImg: '', videoName: '',downloadSure:false},
      { sid: 39, process: 0, videoImg: '', videoName: '',downloadSure:false } ]//downloadSure表示下载
       */
}

/*
H5使用下载流程：
初始化
启动autoDownload()
计时器取得刷新:

问题:
添加时自动下载
自动下载要做当前下载 的判断,不可每次下载添加的

o={"scenicID":1, videoImg: "https://oss.kdkdcn.cn/scenic/haihuangxing/500403582%20copy%403x.png",videoName: "海皇星生态探险乐园", "data":[
 {"videoID":86330106001001,"video_url":"http://oss.kdkdcn.cn/video/yunxizhujing/1.mp4"},
 {"videoID":86330106001002,"video_url":"http://oss.kdkdcn.cn/video/yunxizhujing/2.mp4"},
 ]}
cAddScenicInfos(o)

*/

